format ELF
section '.text' executable

public tuple
public link
public unlink
public left
public right

; ecx = left element, eax = right element, return new tuple in eax
tuple:
	call link
	mov edx,[freelist]
	test edx,edx
	jz .newmem
	mov [edx+4],ecx
	call link
	push ecx
	mov [edx+8],eax
	mov ecx,eax
	call link
	pop ecx
	mov eax,edx
	mov ecx,[edx]
	mov dword[edx],1
	mov [freelist],ecx
	ret
.newmem:
	mov edx,[heap_end]
	add dword[heap_end],12
	mov [edx+4],ecx
	call link
	mov [edx+8],eax
	mov ecx,eax
	call link
	mov eax,edx
	mov dword[edx],1
	ret

; ecx = tuple
unlink:
	test ecx,ecx
	jz .nil
	dec dword[ecx]
	jz .free
.nil:
	ret
.free:
	mov edx,[freelist]
	mov [ecx],edx
	mov [freelist],ecx
	push ecx
	mov ecx,[ecx+4]
	call unlink
	pop ecx
	mov ecx,[ecx+8]
	jmp unlink

; ecx = object
link:
	test ecx,ecx
	jz .nil
	inc dword[ecx]
.nil:
	ret

; eax = pair, return left element in eax
left:
	mov ecx,[eax+4]
	call link
	mov ecx,eax
	call unlink
	mov eax,[eax+4]
	ret

; eax = pair, return right element in eax
right:
	mov ecx,[eax+8]
	call link
	mov ecx,eax
	call unlink
	mov eax,[eax+8]
	ret

section '.data' writeable

heap_end	dd heap_area
freelist	dd 0

section '.bss' writeable

heap_area	rd 0x100000

